# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AccessMode',
    'ActiveRevisionsMode',
    'AppProtocol',
    'BindingType',
    'DisableWwwAuthenticateMode',
    'EasyAuthState',
    'IdentityProviderState',
    'IngressTransportMethod',
    'ManagedServiceIdentityType',
    'PreserveUrlFragmentsForLoginsMode',
    'RequireHttpsMode',
    'StorageType',
    'Type',
    'UnauthenticatedClientAction',
]


class AccessMode(str, Enum):
    """
    Access mode for storage
    """
    READ_ONLY = "ReadOnly"
    READ_WRITE = "ReadWrite"


class ActiveRevisionsMode(str, Enum):
    """
    ActiveRevisionsMode controls how active revisions are handled for the Container app:
    <list><item>Multiple: multiple revisions can be active. If no value if provided, this is the default</item><item>Single: Only one revision can be active at a time. Revision weights can not be used in this mode</item></list>
    """
    MULTIPLE = "multiple"
    SINGLE = "single"


class AppProtocol(str, Enum):
    """
    Tells Dapr which protocol your application is using. Valid options are http and grpc. Default is http
    """
    HTTP = "http"
    GRPC = "grpc"


class BindingType(str, Enum):
    """
    Custom Domain binding type.
    """
    DISABLED = "Disabled"
    SNI_ENABLED = "SniEnabled"


class DisableWwwAuthenticateMode(str, Enum):
    """
    <code>true</code> if the www-authenticate provider should be omitted from the request; otherwise, <code>false</code>.
    """
    TRUE = "True"
    FALSE = "False"


class EasyAuthState(str, Enum):
    """
    <code>Enabled</code> if the Authentication / Authorization feature is enabled for the current app; otherwise, <code>Disabled</code>.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


class IdentityProviderState(str, Enum):
    """
    <code>Disabled</code> if the Twitter provider should not be enabled despite the set registration; otherwise, <code>Enabled</code>.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


class IngressTransportMethod(str, Enum):
    """
    Ingress transport protocol
    """
    AUTO = "auto"
    HTTP = "http"
    HTTP2 = "http2"


class ManagedServiceIdentityType(str, Enum):
    """
    Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned,UserAssigned"


class PreserveUrlFragmentsForLoginsMode(str, Enum):
    """
    <code>True</code> if the fragments from the request are preserved after the login request is made; otherwise, <code>False</code>.
    """
    TRUE = "True"
    FALSE = "False"


class RequireHttpsMode(str, Enum):
    """
    <code>false</code> if the authentication/authorization responses not having the HTTPS scheme are permissible; otherwise, <code>true</code>.
    """
    TRUE = "True"
    FALSE = "False"


class StorageType(str, Enum):
    """
    Storage type for the volume. If not provided, use EmptyDir.
    """
    AZURE_FILE = "AzureFile"
    EMPTY_DIR = "EmptyDir"


class Type(str, Enum):
    """
    The type of probe.
    """
    LIVENESS = "liveness"
    READINESS = "readiness"
    STARTUP = "startup"


class UnauthenticatedClientAction(str, Enum):
    """
    The action to take when an unauthenticated client attempts to access the app.
    """
    REDIRECT_TO_LOGIN_PAGE = "RedirectToLoginPage"
    ALLOW_ANONYMOUS = "AllowAnonymous"
    RETURN401 = "Return401"
    RETURN403 = "Return403"
